#include "proxyhandler.h"
#include <QThread>

bool http::ProxyHandler::loadPlugin(QObject *proxy)
{
    auto inst = qobject_cast<ProxyInterface*>(proxy);
    if(!inst) {
        return false;
    }

    qDebug("loading proxy");

    auto thread = new QThread;
    proxy->moveToThread(thread);
    QObject::connect(thread, SIGNAL (started()), proxy, SLOT (process()));
    //connect(worker, SIGNAL (error(QString)), this, SLOT (errorString(QString)));
    QObject::connect(worker, SIGNAL (httpMessage(http::Flow)), current_session, SLOT (saveFlow(http::Flow)), Qt::QueuedConnection);
    QObject::connect(worker, SIGNAL (httpMessage(http::Flow)), this, SLOT (updateHistory()), Qt::QueuedConnection);

    thread->start();

    proxies.insert({"foo", inst, thread});

    return true;
}
